double Driver::K1999AvoidSteer(tSituation *s)
{
 //memset(&(car->ctrl), 0, sizeof(tCarCtrl));

 // 
 // Find index in data arrays
 //
 int SegId = car->_trkPos.seg->id;
 tTrackSeg *seg = car->_trkPos.seg;
 double dist = car->_trkPos.toStart;
 if (dist < 0)
  dist = 0;
 if (car->_trkPos.seg->type != TR_STR)
  dist *= car->_trkPos.seg->radius;
 int Index = tSegIndex[SegId] + int(dist / tElemLength[SegId]);
 double d = tSegDist[SegId] + dist;
 int Next;
 static const double Time = 0.01;
 double X = car->_pos_X + car->_speed_X * Time / 2;
 double Y = car->_pos_Y + car->_speed_Y * Time / 2;

 Index = thisdiv;
 Next = nextdiv;
 int NextNext = (Next + 1) % Divs;
 int Prev = (Index + Divs - 1) % Divs;

 double c0, c1;
 double txPrev = tx[LINE_RL][Prev], tyPrev = ty[LINE_RL][Prev];
 double txNext = tx[LINE_RL][Next], tyNext = ty[LINE_RL][Next];
 double txIndex = tx[LINE_RL][Index], tyIndex = ty[LINE_RL][Index];
 double txNextNext = tx[LINE_RL][(Next+1)%Divs];
 double tyNextNext = ty[LINE_RL][(Next+1)%Divs];
 float lane2left = tLane[LINE_RL][nextdiv] * seg->width;

 double newlane = seg->width * 0.5 - myoffset ;
 double newleft = newlane;
 double thislane = car->_trkPos.toLeft / seg->width;
 double nextnextlane = newlane + (newlane - thislane);

 if (correcting && currentsimtime > 7.0f)
 {
  if (fabs(nextleft - lane2left) < fabs(newlane - lane2left))
   newlane = nextleft;
  if (fabs(car->_trkPos.toLeft - lane2left) < fabs(newlane - lane2left))
   newlane = car->_trkPos.toLeft;
 }
 float maxlane = 0.35f;
 float minlane = 0.65f;
 newlane /= seg->width;

 txNext = newlane * txRight[LINE_RL][Next] + (1 - newlane) * txLeft[LINE_RL][Next];
 tyNext = newlane * tyRight[LINE_RL][Next] + (1 - newlane) * tyLeft[LINE_RL][Next];
#if 1
 {
  float dist = lastlg < car->_distFromStartLine ? car->_distFromStartLine-lastlg : car->_distFromStartLine - (lastlg - track->length);
  //float lastpos = dist < DivLength ? nextleft - (DivLength/dist) * (nextleft - car->_trkPos.toLeft) : car->_trkPos.toLeft;
  float factor = 0.5;
  if ((segtype == TR_LFT && nextleft > seg->width - 5.0) || (segtype == TR_RGT && nextleft < 5.0) || nextleft + (nextleft - car->_trkPos.toLeft) * 5.0 < car->_dimension_y * 0.3 || nextleft + (nextleft - car->_trkPos.toLeft > seg->width - car->_dimension_y * 0.3))
   factor = 0.5;
  float lastpos = (newleft - (newleft - car->_trkPos.toLeft) * factor);
  float invlane = lastpos / seg->width;//(newlane < 0.5 ? MAX(minlane, tLane[LINE_RL][Index]) : MIN(maxlane, tLane[LINE_RL][Index]));
  txIndex = invlane * txRight[LINE_RL][Index] + (1 - invlane) * txLeft[LINE_RL][Index];
  tyIndex = invlane * tyRight[LINE_RL][Index] + (1 - invlane) * tyLeft[LINE_RL][Index];
  //invlane = (newlane < 0.5 ? MAX(minlane, tLane[LINE_RL][Prev]) : MIN(maxlane, tLane[LINE_RL][Prev]));
  //invlane = newlane;
  txPrev = invlane * txRight[LINE_RL][Prev] + (1 - invlane) * txLeft[LINE_RL][Prev];
  tyPrev = invlane * tyRight[LINE_RL][Prev] + (1 - invlane) * tyLeft[LINE_RL][Prev];
  txNextNext = invlane * txRight[LINE_RL][NextNext] + (1 - invlane) * txLeft[LINE_RL][NextNext];
  tyNextNext = invlane * tyRight[LINE_RL][NextNext] + (1 - invlane) * tyLeft[LINE_RL][NextNext];
  //invlane = prevleft / seg->width;
  //invlane = (newlane < 0.5 ? MAX(minlane, tLane[LINE_RL][NextNext]) : MIN(maxlane, tLane[LINE_RL][NextNext]));
 }
#endif

 c0 = (txNext - txIndex) * (txNext - X) +
      (tyNext - tyIndex) * (tyNext - Y);
 c1 = (txNext - txIndex) * (X - txIndex) +
      (tyNext - tyIndex) * (Y - tyIndex);
 {
  double sum = c0 + c1;
  c0 /= sum;
  c1 /= sum;
 }

 //
 // Find target speed
 //
 float tanksize = GfParmGetNum(car->_carHandle, SECT_CAR, PRM_TANK, (char*) NULL, 100.0f);
 float targetspeed = ((1 - c0) * tSpeed[LINE_RL][Next] + c0 * tSpeed[LINE_RL][Index]);
 if (FuelSpeedup > 0.0f && 0)
 {
  if (tSpeed[LINE_RL][Next] >= tSpeed[LINE_RL][Index])
   targetspeed += (tanksize - car->_fuel) * FuelSpeedup;
  else
   targetspeed += (tanksize - car->_fuel) * (FuelSpeedup / 4);
 }
 if (targetspeed < TargetSpeed)
  TargetSpeed = (TargetSpeed + targetspeed) * 0.5;

 {
  // choose the speed of the raceline we're actually closest to, providing its slower 
  // than the one we're heading towards. Perhaps this'll keep us on the tarmac in
  // eroad.
  float last_lane = car->_trkPos.toLeft / car->_trkPos.seg->width;
  float mindist = FLT_MAX;
  int min = -1;
  for (int i=LINE_LFT; i<=LINE_RL; i++)
  {
   if ((i == LINE_LFT && nextleft >= car->_trkPos.toLeft && (nextleft > lane2left || nextleft > tAvoidLeft[nextdiv])) ||
       (i == LINE_RGT && nextleft <= car->_trkPos.toLeft && (nextleft < lane2left || seg->width-nextleft > tAvoidRight[nextdiv])))
    continue;

   float lane = tLane[i][nextdiv];
   if (fabs(last_lane - lane) < mindist)
   {
    mindist = fabs(last_lane - lane);
    min = i;
   }
  }

  if (min != LINE_RL)
  {
   TargetSpeed = (min == LINE_LFT ? TargetLftSpeed : TargetRgtSpeed);
   rl = min;
   if ((min == LINE_LFT && SEGTYPE(seg) == TR_LFT && (tAvoidRight[nextdiv] > seg->width * 0.5 || (seg->radius < 75.0 && fabs(seg->arc) > 0.12f))) ||
       (min == LINE_RGT && SEGTYPE(seg) == TR_RGT && (tAvoidLeft[nextdiv] > seg->width * 0.5 || (seg->radius < 75.0 && fabs(seg->arc) > 0.12f))))
    TargetSpeed = MIN(TargetLftSpeed, TargetRgtSpeed);
  }
 }

 //
 // Find target curvature (for the inside wheel)
 //
 double TargetCurvature = ((1 - c0) * tRInverse[Next] + c0 * tRInverse[Index]);
 if (fabs(TargetCurvature) > 0.01)
 {
  double r = 1 / TargetCurvature;
  if (r > 0)
   r -= wheeltrack / 2;
  else
   r += wheeltrack / 2;
  TargetCurvature = 1 / r;
 }

 //
 // Steering control
 //
 Error = 0;
 double VnError = 0;
 double Skid = 0;
 CosAngleError = 1;
 SinAngleError = 0;
 float limitfactor = SteerLimit;//1.0 - MIN(0.7, 3.2 - MIN(3.2, CA)) * 0.08;
 if (correcting && !corner_danger)
  limitfactor += (1.0-limitfactor) * 0.5;
 limitfactor -= MAX(0.0, (car->_speed_x < 30 ? 0.0f : (MIN(55.0f, car->_speed_x) - 30.0f) * 0.005));

 float lftlimit = (SEGTYPE(seg) == TR_LFT && !(avoiding&AVOID_LEFT) ? 0.12 : seg->type != TR_RGT ? 0.07 : 0.03) * limitfactor;
 float rgtlimit = (SEGTYPE(seg) == TR_RGT && !(avoiding&AVOID_RIGHT) ? 0.12 : seg->type != TR_LFT ? 0.07 : 0.03) * limitfactor;
 //float lftlimit = (SEGTYPE(seg) == TR_LFT ? 0.11 : seg->type == TR_STR ? 0.07 : (car->_yaw_rate > 0.0 && angle < 0.0 ? 0.3 : 0.01));
 //float rgtlimit = (SEGTYPE(seg) == TR_RGT ? 0.11 : seg->type == TR_STR ? 0.07 : (car->_yaw_rate < 0.0 && angle > 0.0 ? 0.3 : 0.01));
 if (last_flying & FLYING_FRONT)
 {
  rgtlimit *= 0.5;
  lftlimit *= 0.5;
 }
 
 {
  //
  // Ideal value
  //
  if (1)
  {
   double steergain = SteerGain;
   if (segtype == TR_LFT && nextleft - car->_dimension_y * 0.2 < 0.0)
    steergain = MAX(1.0, steergain - fabs(nextleft - car->_dimension_y * 0.5));
   else if (segtype == TR_RGT && nextleft + car->_dimension_y * 0.2 > seg->width)
    steergain = MAX(1.0, steergain - ((nextleft + car->_dimension_y * 0.5) - seg->width));
   if (seg->type != TR_LFT && nextleft - car->_dimension_y * 0.5 < 0.0)
    steergain += fabs(nextleft - car->_dimension_y * 0.5) * 0.5;
   else if (seg->type != TR_RGT && nextleft + car->_dimension_y * 0.5 > seg->width)
    steergain += ((nextleft + car->_dimension_y * 0.5) - seg->width) * 0.5;

   double s = atan(wheelbase * steergain * TargetCurvature) / car->_steerLock;
   
   k1999steer_a = s;
  }

  //
  // Servo system to stay on the pre-computed path
  //
  {
   double dx = txNext - txIndex;
   double dy = tyNext - tyIndex;
   Error = (dx * (Y - tyIndex) - dy * (X - txIndex)) / Mag(dx, dy);
  }  

  double Prevdx = txNext - txPrev;
  double Prevdy = tyNext - tyPrev;
  double Nextdx = txNextNext - txIndex;
  double Nextdy = tyNextNext - tyIndex;
  double dx = c0 * Prevdx + (1 - c0) * Nextdx;
  double dy = c0 * Prevdy + (1 - c0) * Nextdy;
  double n = Mag(dx, dy);
  dx /= n;
  dy /= n;
  double speed = Mag(car->_speed_Y, car->_speed_X);
  double sError = (dx * car->_speed_Y - dy * car->_speed_X) / (speed + 0.01);
  double cError = (dx * car->_speed_X + dy * car->_speed_Y) / (speed + 0.01);
  VnError = asin(sError);
  if (cError < 0)
   VnError = PI - VnError;

  k1999steer_a -= (atan(Error * (300 / (speed + 300)) / 15) + VnError) / car->_steerLock;

  //
  // Steer into the skid
  //
  double vx = car->_speed_X;
  double vy = car->_speed_Y;
  double dirx = cos(car->_yaw);
  double diry = sin(car->_yaw);
  CosAngleError = dx * dirx + dy * diry;
  SinAngleError = dx * diry - dy * dirx;
  Skid = (dirx * vy - vx * diry) / (speed + 0.1);
  if (Skid > 0.9)
   Skid = 0.9;
  if (Skid < -0.9)
   Skid = -0.9;
  k1999steer_a += asin(Skid) / car->_steerLock;

  double yr = speed * TargetCurvature;
  double diff = car->_yaw_rate - yr;
  double steerskid = SteerSkid;
  if ((correcting || flying_timer > currentsimtime - 3.5) && 
      (segtype == TR_STR ||
       (segtype == TR_RGT && nextleft > 4.0f) ||
       (segtype == TR_LFT && nextleft < seg->width - 4.0f) ||
       (flying_timer < currentsimtime - 3.5 && (nextleft <= 0.0 || nextleft >= seg->width))))
  {
   steerskid = MAX(SteerSkid, MIN(0.24, SteerSkid + MIN(0.2, fabs(laststeer-lastksteer) * 0.7)));
   if (flying_timer > currentsimtime - 3.5)
   {
    steerskid= MAX((0.20 + (3.5 - (currentsimtime - flying_timer)) * 0.08), SteerSkid);
   }
   else if ((nextleft <= 0.0 || nextleft >= seg->width) && steerskid > SteerSkid)
    steerskid = MAX(steerskid * (0.3 - fabs(angle)*0.5), SteerSkid);
  }

  k1999steer_a -= (steerskid * (1 + fDirt) * (100 / (speed + 100)) * diff) / car->_steerLock;
  if ((last_flying & FLYING_FRONT) && fabs(angle) < 0.3 && nextleft > 0.5f && nextleft < seg->width - 0.5f)
  {
   k1999steer_a = MAX(-0.1, MIN(0.1, k1999steer_a));
  }

  //if ((angle > 1.6f && car->_trkPos.toRight > 3.0 && k1999steer_a < 0.0 && car->_yaw_rate < -0.5) || 
  //    (angle < -1.6f && car->_trkPos.toLeft > 3.0 && k1999steer_a > 0.0 && car->_yaw_rate > 0.5))
  // k1999steer_a = -k1999steer_a;

  //if (!correcting)
   k1999steer_a = MAX(laststeer - rgtlimit, MIN(laststeer + lftlimit, k1999steer_a));
 }
